## slop 4.2.20

=== CMakeLists.txt ===
cmake_minimum_required( VERSION 2.8 )

project( "slop" )
set( slop_VERSION_MAJOR 4 )
set( slop_VERSION_MINOR 2 )
set( slop_VERSION_PATCH 20 )

set( CMAKE_OPENGL_SUPPORT FALSE CACHE BOOL "Whether or not to compile with OpenGL, shaders, magnification, and theming support." )

set( BIN_TARGET     "${PROJECT_NAME}" )
if( NOT CMAKE_INSTALL_PREFIX )
   set( CMAKE_INSTALL_PREFIX "/usr" )
endif()

if( NOT CMAKE_CONFIGURATION_TYPES AND NOT CMAKE_BUILD_TYPE )
   set( CMAKE_BUILD_TYPE RelWithDebInfo )
endif()

# Linux compiler initialization.
if ( "${CMAKE_CXX_COMPILER_ID}" STREQUAL "Clang" OR
     "${CMAKE_CXX_COMPILER_ID}" STREQUAL "GNU" OR
     "${CMAKE_CXX_COMPILER_ID}" STREQUAL "Intel" )
     set( CMAKE_CXX_FLAGS "${CMAKE_CXX_FLAGS} -Wall -Wno-unused-parameter" )
     set( CMAKE_CXX_FLAGS_DEBUG "-Wextra -pedantic-errors -O0 -g" )
     set( CMAKE_CXX_FLAGS_RELEASE "-O2" )
     set( CMAKE_CXX_FLAGS_RELWITHDEBINFO "-O2 -g" )
         # -Wall:   Enable all warnings.
         # -Wextra: Enable some more warnings.
         # -Werror: Have errors on warnings.
         # -pedantic-errors: Even more errors.
         # -Wno-unused-parameter: Prevent unused variable warning. (Several functions are required to have unecessary variables because X11.)
else()
    message( FATAL_ERROR "Your operating system isn't supported yet! CMake will now exit." )
endif()

# Add a check target for our makefile.
find_program( CPPCHECK_EXECUTABLE cppcheck
              DOC "A tool for static C/C++ code analysis." )
if (CPPCHECK_EXECUTABLE)
    add_custom_target( "check"
                       COMMAND "${CPPCHECK_EXECUTABLE}" "--enable=all" "*"
                       WORKING_DIRECTORY src VERBATIM )
endif()

# Here we generate some of our code if we can. I package it pre-generated
# so nobody has to go find and install gengetopt if they don't want to.
find_program( GENGETOPT_EXECUTABLE gengetopt
              DOC "A tool to generate code to grab command line options." )
find_program( SED_EXECUTABLE sed )
if ( GENGETOPT_EXECUTABLE AND SED_EXECUTABLE )
    message( "-- Regenerating cmdline.in" )
    # gengetopt generates cmdline.h, then we move it to cmdline.in.
    execute_process( COMMAND "${GENGETOPT_EXECUTABLE}" "--input=options.ggo"
                     WORKING_DIRECTORY "${CMAKE_CURRENT_SOURCE_DIR}/src" )
    file( RENAME "${CMAKE_CURRENT_SOURCE_DIR}/src/cmdline.h" "${CMAKE_CURRENT_SOURCE_DIR}/src/cmdline.in" )
    # Due to a bug in gengetopt, we have to manually insert some code.
    # Replace the first instance of REPLACEME with some text.
    # Eight backslashes = two in the code because of how many instances of escaping is happening.
    execute_process( COMMAND "${SED_EXECUTABLE}" "-i" "0,/REPLACEME/{s/REPLACEME/X=%x\\\\\\\\nY=%y\\\\\\\\nW=%w\\\\\\\\nH=%h\\\\\\\\nG=%g\\\\\\\\nID=%i\\\\\\\\nCancel=%c\\\\\\\\n/}" "cmdline.c"
                     WORKING_DIRECTORY "${CMAKE_CURRENT_SOURCE_DIR}/src" )
    # Then replace remaining instances.
    execute_process( COMMAND "${SED_EXECUTABLE}" "-i" "s/REPLACEME/X=%x\\\\nY=%y\\\\nW=%w\\\\nH=%h\\\\nG=%g\\\\nID=%i\\\\nCancel=%c\\\\n/" "cmdline.c"
                     WORKING_DIRECTORY "${CMAKE_CURRENT_SOURCE_DIR}/src" )
else()
    message( "Warning: Command gengetopt or sed not found! Won't regenerate command line code. (If you're just compiling this doesn't matter.)" )
endif()

# By default our src/options.ggo has our cmake versions variables for
# the 'version ""' line. We replace them here.
# The ${CMAKE_SOURCE_DIR} is there to fix problems with OpenBSD's out-of-source build black magic.
configure_file( "src/cmdline.in" "${CMAKE_SOURCE_DIR}/src/cmdline.h" )

# This allows for "make README.md" to be ran to update the README's help
# section automatically. We don't add it to ALL because running arbitrary
# scripts is unsafe and I don't know if systems will actually have it
# be executbable.
add_custom_target( README.md "./generateReadme.sh" DEPENDS "slop" )

# Sources
if( CMAKE_OPENGL_SUPPORT )
    set( source
         src/cmdline.c
         src/selectrectangle.cpp
         src/glselectrectangle.cpp
         src/shader.cpp
         src/framebuffer.cpp
         src/resource.cpp
         src/xselectrectangle.cpp
         src/x.cpp
         src/main.cpp )
else()
    set( source
         src/cmdline.c
         src/selectrectangle.cpp
         src/xselectrectangle.cpp
         src/x.cpp
         src/main.cpp )
endif()

# Obtain library paths and make sure they exist.
set( CMAKE_MODULE_PATH ${CMAKE_MODULE_PATH} "${CMAKE_SOURCE_DIR}/cmakemodules" )
find_package( Imlib2    REQUIRED )
find_package( X11       REQUIRED )
find_package( XExt      REQUIRED )
find_package( OpenGL    REQUIRED )
find_package( GLX       REQUIRED )
find_package( XRender   REQUIRED )
find_package( XRandr    REQUIRED )
find_package( GLEW      REQUIRED )
# This library is needed only for Ubuntu it seems, some platforms don't even
# ship with it. I couldn't find a way to do a test compile to check if librt
# was needed, so instead I just didn't mark it as REQUIRED.
find_package( RT )

set( CMAKE_CXX_FLAGS
     "${CMAKE_CXX_FLAGS} ${CMAKE_IMLIB2_CXX_FLAGS}" )

# Includes
include_directories( "${X11_INCLUDE_DIR}"
                     "${XEXT_INCLUDE_DIR}" )

if ( CMAKE_OPENGL_SUPPORT )
include_directories( "${IMLIB2_INCLUDE_DIR}"
                     "${XRANDR_INCLUDE_DIR}"
                     "${OPENGL_INCLUDE_DIR}"
                     "${GLX_INCLUDE_DIR}"
                     ${GLEW_INCLUDE_DIRS}
                     ${XRENDER_INCLUDE_DIRS} )
endif()

if ( RT_INCLUDE_DIR )
    include_directories( ${RT_INCLUDE_DIR} )
endif()

# Executable
add_executable( "${BIN_TARGET}" ${source} )

# Libraries
target_link_libraries( "${BIN_TARGET}"
                       ${X11_LIBRARIES}
                       "${XEXT_LIBRARY}" )

if ( CMAKE_OPENGL_SUPPORT )
    target_link_libraries( "${BIN_TARGET}"
                           ${IMLIB2_LIBRARIES}
                           ${OPENGL_LIBRARIES}
                           ${GLX_LIBRARIES}
                           ${GLEW_LIBRARIES}
                           ${XRENDER_LIBRARIES}
                           "${XRANDR_LIBRARY}" )
endif()


if ( RT_LIBRARY )
    target_link_libraries( "${BIN_TARGET}"
                           "${RT_LIBRARY}" )
endif()

install( TARGETS ${BIN_TARGET}
         DESTINATION "${CMAKE_INSTALL_PREFIX}/bin" )

add_definitions(-DINSTALL_PREFIX="${CMAKE_INSTALL_PREFIX}")

if( CMAKE_OPENGL_SUPPORT )
    install( DIRECTORY "${CMAKE_SOURCE_DIR}/share"
             DESTINATION "${CMAKE_INSTALL_PREFIX}" )
    add_definitions(-DOPENGL_ENABLED=1)
endif()

=== debian/changelog ===
slop (4.2.20-1mx150+1) mx; urgency=medium

  * Rebuild for MX-15.

 -- Steven Pusser (Stevo) <maintainer@mepiscommunity.org>  Sat, 11 Jun 2016 14:44:38 -0700

slop (4.2.20-1~webupd8~trusty1) trusty; urgency=medium

  * Initial debianization

 -- Alin Andrei <webupd8@gmail.com>  Tue, 10 Nov 2015 14:28:19 +0200

=== debian/control ===
Source: slop
Section: utils
Priority: extra
Maintainer: Steven Pusser (Stevo) <maintainer@mepiscommunity.org>
Bugs: mailto: maintainer@mepiscommunity.org
XSBC-Original-Maintainer: Alin Andrei <webupd8@gmail.com>
Build-Depends: debhelper (>= 9),
 cmake,
 libglew-dev,
 libimlib2-dev,
 libx11-dev,
 libxext-dev,
 libxrandr-dev,
 mesa-common-dev,
 libglm-dev
Standards-Version: 3.9.6

Package: slop
Architecture: any
Depends: ${shlibs:Depends}, ${misc:Depends}
Description: queries for selection from the user and prints the region to stdout
 slop (Select Operation) is an application that querys for a selection from the
 user and prints the region to stdout. It grabs the mouse and turns it into a
 crosshair, lets the user click and drag to make a selection (or click on a 
 window) while drawing a pretty box around it, then finally prints the
 selection's dimensions to stdout.

## slop 4.3.21

=== CMakeLists.txt ===
--- 
+++ 
@@ -2,14 +2,18 @@
 
 project( "slop" )
 set( slop_VERSION_MAJOR 4 )
-set( slop_VERSION_MINOR 2 )
-set( slop_VERSION_PATCH 20 )
+set( slop_VERSION_MINOR 3 )
+set( slop_VERSION_PATCH 21 )
 
 set( CMAKE_OPENGL_SUPPORT FALSE CACHE BOOL "Whether or not to compile with OpenGL, shaders, magnification, and theming support." )
 
 set( BIN_TARGET     "${PROJECT_NAME}" )
 if( NOT CMAKE_INSTALL_PREFIX )
    set( CMAKE_INSTALL_PREFIX "/usr" )
+endif()
+
+if( NOT INSTALL_PREFIX )
+   set( INSTALL_PREFIX "${CMAKE_INSTALL_PREFIX}" CACHE PATH "The path where slop thinks it resides in, so that it can find the shaders. This is not necessarily the CMAKE_INSTALL_PREFIX. For example if the shaders will exist in /usr/share/slop, INSTALL_PREFIX should be \"/usr\"." )
 endif()
 
 if( NOT CMAKE_CONFIGURATION_TYPES AND NOT CMAKE_BUILD_TYPE )
@@ -159,7 +163,7 @@
 install( TARGETS ${BIN_TARGET}
          DESTINATION "${CMAKE_INSTALL_PREFIX}/bin" )
 
-add_definitions(-DINSTALL_PREFIX="${CMAKE_INSTALL_PREFIX}")
+add_definitions(-DINSTALL_PREFIX="${INSTALL_PREFIX}")
 
 if( CMAKE_OPENGL_SUPPORT )
     install( DIRECTORY "${CMAKE_SOURCE_DIR}/share"

=== debian/changelog ===
slop (4.3.21-1) unstable; urgency=low

  * Initial release (Closes: #842974)

 -- Antoine Beaupré <anarcat@debian.org>  Wed, 02 Nov 2016 15:08:14 -0400

=== debian/control ===
Source: slop
Section: x11
Priority: optional
Maintainer: Antoine Beaupré <anarcat@debian.org>
Build-Depends: debhelper (>= 9)
             , cmake
             , libxext-dev
             , libimlib2-dev
             , libxrender-dev
             , libxrandr-dev
             , libglew-dev
             , libglm-dev
Standards-Version: 3.9.8
Homepage: https://github.com/naelstrof/slop
Vcs-Git: git://anonscm.debian.org/collab-maint/slop.git
Vcs-Browser: http://anonscm.debian.org/?p=collab-maint/slop.git;a=summary

Package: slop
Architecture: any
Depends: ${shlibs:Depends}, ${misc:Depends}
Description: queries for a selection from the user and prints the region to stdout
 slop (Select Operation) is an application that queries for a
 selection from the user and prints the region to stdout. It grabs the
 mouse and turns it into a crosshair, lets the user click and drag to
 make a selection (or click on a window) while drawing a pretty box
 around it, then finally prints the selection's dimensions to stdout.
 .
 Features:
 .
  * Hovering over a window will cause a selection rectangle to appear
    over it.
  * Clicking on a window makes slop return the dimensions of the
    window.
  * Clicking and dragging causes a selection rectangle to appear,
    renders pretty well (compared to scrot). And will return the
    dimensions of that rectangle in absolute screen coords.
  * On startup it turns your cursor into a crosshair, then adjusts the
    cursor into angles as you drag the selection rectangle.
  * Supports simple arguments:
  * Change selection rectangle border size.
  * Select X display.
  * Set padding size, even negative padding sizes!
  * Set click tolerance for if you have a shaky mouse.
  * Set the color of the selection rectangles to match your theme!
    (Even supports transparency!)
  * Remove window decorations from selections.
  * Supports OpenGL hardware acceleration.
  * Supports textured themes.
  * Supports programmable shaders.
  * Supports a magnifying glass.

=== debian/rules ===
#!/usr/bin/make -f
# See debhelper(7) (uncomment to enable)
# output every command that modifies files on the build system.
#DH_VERBOSE = 1

# see EXAMPLES in dpkg-buildflags(1) and read /usr/share/dpkg/*
DPKG_EXPORT_BUILDFLAGS = 1
include /usr/share/dpkg/default.mk

# see FEATURE AREAS in dpkg-buildflags(1)
export DEB_BUILD_MAINT_OPTIONS = hardening=+all

# see ENVIRONMENT in dpkg-buildflags(1)
# package maintainers to append CFLAGS
export DEB_CFLAGS_MAINT_APPEND  = -Wall -pedantic
# package maintainers to append LDFLAGS
export DEB_LDFLAGS_MAINT_APPEND = -Wl,--as-needed


# main packaging script based on dh7 syntax
%:
	dh $@ 

override_dh_auto_configure:
	dh_auto_configure -- -DCMAKE_OPENGL_SUPPORT=true

## slop 6.3.47

=== debian/changelog ===
slop (6.3.47-1) unstable; urgency=medium

  * New upstream release
  * fix missing list indent in package description (Closes: #848251)
  * reduce dependencies as per upstream README
  * disable UNICODE support to avoid linking against libicu, file a bug if
    that causes problems
  * bump debhelper compatibility to 10

 -- Antoine Beaupré <anarcat@debian.org>  Thu, 20 Jul 2017 19:06:52 -0400

## slop 7.3.49

=== CMakeLists.txt ===
cmake_minimum_required(VERSION 3.1.3)

set(CMAKE_BUILD_TYPE Debug CACHE STRING "Choose the type of build (Debug or Release)")

if ( NOT CMAKE_INSTALL_PREFIX )
    set(CMAKE_INSTALL_PREFIX "/usr")
endif()

# This should really never be disabled. The pure-X mode of slop is very expensive and buggy.
# It also doesn't work on Wayland. Though if a system is never running a compositor, or
# doesn't have OpenGL, this could remove some linking dependencies I suppose.
set( SLOP_OPENGL TRUE CACHE BOOL "To enable or disable OpenGL support." )
if ( SLOP_OPENGL )
  add_definitions(-DSLOP_OPENGL="True")
endif()

project(slop)

set(CMAKE_RUNTIME_OUTPUT_DIRECTORY "${CMAKE_SOURCE_DIR}/bin/")

set( CMAKE_INSTALL_MANDIR "${CMAKE_INSTALL_PREFIX}/share/man" CACHE PATH "Directory where man pages reside. (/usr/share/man, /usr/local/share/man, etc.)" )

set( CMAKE_COMPRESS_MAN TRUE CACHE BOOL "Whether or not to compress the man pages for install." )

if ( CMAKE_COMPRESS_MAN )
    set( MANTARGET "slop.1.gz" )
else()
    set( MANTARGET "slop.1" )
endif()

include_directories("${PROJECT_BINARY_DIR}")

add_definitions(-DSLOP_VERSION="v7.3.49")

# The names have to be unique unfortunately.
set(EXECUTABLE_NAME "slop")
set(LIBRARY_NAME "slopy")


if ( SLOP_OPENGL )
  add_library(${LIBRARY_NAME} SHARED  src/mouse.cpp
                                      src/keyboard.cpp
                                      src/x.cpp
                                      src/slopstates.cpp
                                      src/resource.cpp
                                      src/slop.cpp
                                      src/rectangle.cpp
                                      src/xshaperectangle.cpp
                                      src/shader.cpp
                                      src/window.cpp
                                      src/framebuffer.cpp
                                      src/glrectangle.cpp)
else()
  add_library(${LIBRARY_NAME} SHARED  src/mouse.cpp
                                      src/keyboard.cpp
                                      src/x.cpp
                                      src/slopstates.cpp
                                      src/resource.cpp
                                      src/slop.cpp
                                      src/rectangle.cpp
                                      src/xshaperectangle.cpp)
endif()

set_property(TARGET ${LIBRARY_NAME} PROPERTY CXX_STANDARD_REQUIRED ON)
set_property(TARGET ${LIBRARY_NAME} PROPERTY CXX_STANDARD 11)

add_executable(${EXECUTABLE_NAME} src/main.cpp)

set_property(TARGET ${EXECUTABLE_NAME} PROPERTY CXX_STANDARD_REQUIRED ON)
set_property(TARGET ${EXECUTABLE_NAME} PROPERTY CXX_STANDARD 11)

set( CMAKE_MODULE_PATH ${CMAKE_MODULE_PATH} "${CMAKE_SOURCE_DIR}/modules" )

find_package(GLM REQUIRED)
find_package(X11 REQUIRED)
find_package(XExt REQUIRED)

if ( SLOP_OPENGL )
  find_package(GLEW REQUIRED)
  find_package(OpenGL REQUIRED)
  find_package(GLX REQUIRED)
  find_package(XRender REQUIRED)
  # Ahhhh, finally this eliminates the segfault on preload.
  find_package(Threads REQUIRED)
endif()

include_directories(${X11_INCLUDE_DIR}
                    ${GLM_INCLUDE_DIR}
                    ${GLX_INCLUDE_DIR})

target_link_libraries(${LIBRARY_NAME} ${X11_LIBRARIES}
                                      ${GLM_LIBRARIES}
                                      ${XEXT_LIBRARIES})

if ( SLOP_OPENGL )
  include_directories( ${XEXT_INCLUDE_DIR}
                       ${GLEW_INCLUDE_DIR}
                       ${XRENDER_INCLUDE_DIR}
                       ${OPENGL_INCLUDE_DIR} )
  target_link_libraries(${LIBRARY_NAME} ${OPENGL_LIBRARIES}
                                        ${XRENDER_LIBRARY}
                                        ${CMAKE_THREAD_LIBS_INIT} 
                                        ${GLX_LIBRARY}
                                        ${GLEW_LIBRARIES})
endif()

target_link_libraries(${EXECUTABLE_NAME} ${LIBRARY_NAME} )

if( CMAKE<3.7 )
  message( WARNING "CMake version is below 3.7, CMake version >= 3.7 is required for unicode support." )
else()
  find_package(ICU COMPONENTS uc)
  set( SLOP_UNICODE TRUE CACHE BOOL "To enable or disable unicode support." )
  if ( SLOP_UNICODE AND ICU_FOUND )
    add_definitions(-DCXXOPTS_USE_UNICODE)
    include_directories( ${ICU_INCLUDE_DIR} )
    target_link_libraries(${EXECUTABLE_NAME} ${ICU_UC_LIBRARIES} )
  endif()
endif()

install( TARGETS ${EXECUTABLE_NAME} DESTINATION "${CMAKE_INSTALL_PREFIX}/bin" )
install( TARGETS ${LIBRARY_NAME} DESTINATION "${CMAKE_INSTALL_PREFIX}/lib" )
install( FILES ${CMAKE_SOURCE_DIR}/src/slop.hpp DESTINATION "${CMAKE_INSTALL_PREFIX}/include" COMPONENT development )
install( FILES "${CMAKE_SOURCE_DIR}/${MANTARGET}" DESTINATION  "${CMAKE_INSTALL_MANDIR}/man1" COMPONENT doc )

=== debian/changelog ===
slop (7.3.49-1build2) bionic; urgency=medium

  * No-change rebuild for icu soname change.

 -- Matthias Klose <doko@ubuntu.com>  Tue, 07 Nov 2017 08:55:43 +0000

slop (7.3.49-1build1) bionic; urgency=medium

  * No-change rebuild for libicu soname change.

 -- Matthias Klose <doko@ubuntu.com>  Wed, 25 Oct 2017 15:48:45 +0000

slop (7.3.49-1) unstable; urgency=medium

  * New upstream release
  * bump policy version to 4.1.0, no change

 -- Antoine Beaupré <anarcat@debian.org>  Wed, 23 Aug 2017 15:37:52 -0400

=== debian/control ===
--- 
+++ 
@@ -2,18 +2,18 @@
 Section: x11
 Priority: optional
 Maintainer: Antoine Beaupré <anarcat@debian.org>
-Build-Depends: debhelper (>= 9)
-             , cmake
-             , libxext-dev
-             , libimlib2-dev
-             , libxrender-dev
-             , libxrandr-dev
+Build-Depends: debhelper (>= 10~)
+             , cmake (>= 3.1.3~)
+             , libegl1-mesa-dev
+             , libicu-dev
              , libglew-dev
              , libglm-dev
+             , libxrender-dev
+             , pkg-config
 Standards-Version: 3.9.8
 Homepage: https://github.com/naelstrof/slop
 Vcs-Git: git://anonscm.debian.org/collab-maint/slop.git
-Vcs-Browser: http://anonscm.debian.org/?p=collab-maint/slop.git;a=summary
+Vcs-Browser: https://anonscm.debian.org/cgit/collab-maint/slop.git/
 
 Package: slop
 Architecture: any
@@ -37,15 +37,14 @@
   * On startup it turns your cursor into a crosshair, then adjusts the
     cursor into angles as you drag the selection rectangle.
   * Supports simple arguments:
-  * Change selection rectangle border size.
-  * Select X display.
-  * Set padding size, even negative padding sizes!
-  * Set click tolerance for if you have a shaky mouse.
-  * Set the color of the selection rectangles to match your theme!
-    (Even supports transparency!)
+    * Change selection rectangle border size.
+    * Select X display.
+    * Set padding size, even negative padding sizes!
+    * Set click tolerance for if you have a shaky mouse.
+    * Set the color of the selection rectangles to match your theme!
+      (Even supports transparency!)
   * Remove window decorations from selections.
   * Supports OpenGL hardware acceleration.
   * Supports textured themes.
   * Supports programmable shaders.
   * Supports a magnifying glass.
-

## slop 7.4

=== CMakeLists.txt ===
cmake_minimum_required(VERSION 3.1.3)

project(slop VERSION 7.4 LANGUAGES CXX)

set(CMAKE_BUILD_TYPE Debug CACHE STRING "Choose the type of build (Debug or Release)")

if(CMAKE_INSTALL_PREFIX_INITIALIZED_TO_DEFAULT)
  set(CMAKE_INSTALL_PREFIX "/usr" CACHE PATH "..." FORCE)
endif()

include(GNUInstallDirs)

set( BUILD_SHARED_LIBS ON CACHE BOOL "Build all libraries as shared" )

# This should really never be disabled. The pure-X mode of slop is very expensive and buggy.
# It also doesn't work on Wayland. Though if a system is never running a compositor, or
# doesn't have OpenGL, this could remove some linking dependencies I suppose.
set( SLOP_OPENGL TRUE CACHE BOOL "To enable or disable OpenGL support." )
if ( SLOP_OPENGL )
  add_definitions(-DSLOP_OPENGL="True")
endif()

set(CMAKE_RUNTIME_OUTPUT_DIRECTORY "${CMAKE_SOURCE_DIR}/bin/")

include_directories("${PROJECT_BINARY_DIR}")

add_definitions(-DSLOP_VERSION="v${PROJECT_VERSION}")

# The names have to be unique unfortunately.
set(EXECUTABLE_NAME "slop")
set(LIBRARY_NAME "slopy")

add_library(${LIBRARY_NAME}
  src/mouse.cpp
  src/keyboard.cpp
  src/x.cpp
  src/slopstates.cpp
  src/resource.cpp
  src/slop.cpp
  src/rectangle.cpp
  src/xshaperectangle.cpp)
set_target_properties(${LIBRARY_NAME}
  PROPERTIES
  VERSION ${PROJECT_VERSION}
  SOVERSION ${PROJECT_VERSION})

if ( SLOP_OPENGL )
  target_sources(${LIBRARY_NAME} PRIVATE
    src/shader.cpp
    src/window.cpp
    src/framebuffer.cpp
    src/glrectangle.cpp)
endif()

set_property(TARGET ${LIBRARY_NAME} PROPERTY CXX_STANDARD_REQUIRED ON)
set_property(TARGET ${LIBRARY_NAME} PROPERTY CXX_STANDARD 11)
set_property(TARGET ${LIBRARY_NAME} PROPERTY CXX_EXTENSIONS OFF)

add_executable(${EXECUTABLE_NAME} src/main.cpp)

set_property(TARGET ${EXECUTABLE_NAME} PROPERTY CXX_STANDARD_REQUIRED ON)
set_property(TARGET ${EXECUTABLE_NAME} PROPERTY CXX_STANDARD 11)
set_property(TARGET ${EXECUTABLE_NAME} PROPERTY CXX_EXTENSIONS OFF)

set( CMAKE_MODULE_PATH ${CMAKE_MODULE_PATH} "${CMAKE_SOURCE_DIR}/modules" )

find_package(GLM REQUIRED)
find_package(X11 REQUIRED)
find_package(XExt REQUIRED)

if ( SLOP_OPENGL )
  find_package(GLEW REQUIRED)
  find_package(OpenGL REQUIRED)
  find_package(GLX REQUIRED)
  find_package(XRender REQUIRED)
  # Ahhhh, finally this eliminates the segfault on preload.
  find_package(Threads REQUIRED)
endif()

include_directories(${X11_INCLUDE_DIR}
                    ${GLM_INCLUDE_DIR}
                    ${GLX_INCLUDE_DIR})

target_link_libraries(${LIBRARY_NAME} ${X11_LIBRARIES}
                                      ${GLM_LIBRARIES}
                                      ${XEXT_LIBRARIES})

if ( SLOP_OPENGL )
  include_directories( ${XEXT_INCLUDE_DIR}
                       ${GLEW_INCLUDE_DIR}
                       ${XRENDER_INCLUDE_DIR}
                       ${OPENGL_INCLUDE_DIR} )
  target_link_libraries(${LIBRARY_NAME} ${OPENGL_LIBRARIES}
                                        ${XRENDER_LIBRARY}
                                        ${CMAKE_THREAD_LIBS_INIT} 
                                        ${GLX_LIBRARY}
                                        ${GLEW_LIBRARIES})
endif()

target_link_libraries(${EXECUTABLE_NAME} ${LIBRARY_NAME} )

if( CMAKE<3.7 )
  message( WARNING "CMake version is below 3.7, CMake version >= 3.7 is required for unicode support." )
else()
  find_package(ICU COMPONENTS uc)
  set( SLOP_UNICODE TRUE CACHE BOOL "To enable or disable unicode support." )
  if ( SLOP_UNICODE AND ICU_FOUND )
    add_definitions(-DCXXOPTS_USE_UNICODE)
    include_directories( ${ICU_INCLUDE_DIR} )
    target_link_libraries(${EXECUTABLE_NAME} ${ICU_UC_LIBRARIES} )
  endif()
endif()

install( TARGETS ${EXECUTABLE_NAME} DESTINATION "${CMAKE_INSTALL_BINDIR}" )
install( TARGETS ${LIBRARY_NAME} DESTINATION "${CMAKE_INSTALL_LIBDIR}" )
install( FILES ${CMAKE_SOURCE_DIR}/src/slop.hpp DESTINATION "${CMAKE_INSTALL_INCLUDEDIR}" COMPONENT development )
install( FILES ${CMAKE_SOURCE_DIR}/slop.1 DESTINATION "${CMAKE_INSTALL_MANDIR}/man1" COMPONENT doc )

=== debian/changelog ===
slop (7.4-1build2) disco; urgency=medium

  * No-change rebuild against latest glew

 -- Jeremy Bicha <jbicha@ubuntu.com>  Fri, 23 Nov 2018 20:05:34 -0500

slop (7.4-1build1) disco; urgency=medium

  * No-change rebuild for icu soname changes.

 -- Matthias Klose <doko@ubuntu.com>  Tue, 13 Nov 2018 08:20:29 +0000

slop (7.4-1) unstable; urgency=medium

  * new upstream release
  * point Vcs-* URLs to salsa
  * update standards: no change

 -- Antoine Beaupré <anarcat@debian.org>  Mon, 27 Aug 2018 16:30:07 -0400

=== debian/control ===
--- 
+++ 
@@ -10,10 +10,10 @@
              , libglm-dev
              , libxrender-dev
              , pkg-config
-Standards-Version: 3.9.8
+Standards-Version: 4.2.1.0
 Homepage: https://github.com/naelstrof/slop
-Vcs-Git: git://anonscm.debian.org/collab-maint/slop.git
-Vcs-Browser: https://anonscm.debian.org/cgit/collab-maint/slop.git/
+Vcs-Git: https://salsa.debian.org/debian/slop.git
+Vcs-Browser: https://salsa.debian.org/debian/slop
 
 Package: slop
 Architecture: any

=== debian/rules ===
--- 
+++ 
@@ -20,10 +20,3 @@
 # main packaging script based on dh7 syntax
 %:
 	dh $@ 
-
-override_dh_auto_configure:
-	dh_auto_configure -- -DCMAKE_OPENGL_SUPPORT=true
-
-
-
-

## slop 7.5

=== CMakeLists.txt ===
--- 
+++ 
@@ -1,6 +1,6 @@
 cmake_minimum_required(VERSION 3.1.3)
 
-project(slop VERSION 7.4 LANGUAGES CXX)
+project(slop VERSION 7.5 LANGUAGES CXX)
 
 set(CMAKE_BUILD_TYPE Debug CACHE STRING "Choose the type of build (Debug or Release)")

=== debian/changelog ===
slop (7.5-1) unstable; urgency=medium

  * New upstrem release

 -- Antoine Beaupré <anarcat@debian.org>  Sun, 10 May 2020 23:36:44 -0400

slop (7.4-2) unstable; urgency=medium

  [ Ondřej Nový ]
  * d/copyright: Use https protocol in Format field
  * d/rules: Remove trailing whitespaces

  [ Antoine Beaupré ]
  * fix FTBFS, thanks Sebastian Ramacher! (Closes: #951941)

 -- Antoine Beaupré <anarcat@debian.org>  Mon, 24 Feb 2020 11:38:34 -0500

=== debian/control ===
--- 
+++ 
@@ -8,6 +8,7 @@
              , libicu-dev
              , libglew-dev
              , libglm-dev
+             , libxext-dev
              , libxrender-dev
              , pkg-config
 Standards-Version: 4.2.1.0

=== debian/rules ===
--- 
+++ 
@@ -19,4 +19,4 @@
 
 # main packaging script based on dh7 syntax
 %:
-	dh $@ 
+	dh $@

## slop 7.6

=== CMakeLists.txt ===
--- 
+++ 
@@ -1,6 +1,6 @@
 cmake_minimum_required(VERSION 3.1.3)
 
-project(slop VERSION 7.5 LANGUAGES CXX)
+project(slop VERSION 7.6 LANGUAGES CXX)
 
 set(CMAKE_BUILD_TYPE Debug CACHE STRING "Choose the type of build (Debug or Release)")

=== debian/changelog ===
slop (7.6-5) unstable; urgency=medium

  [ Debian Janitor ]
  * Refer to common license file for Apache-2.0.
  * Bump debhelper from old 10 to 13.
  * Set debhelper-compat version in Build-Depends.
  * Set upstream metadata fields: Bug-Database, Bug-Submit, Repository-Browse.
  * Remove listed license files (COPYING) from copyright.
  * Avoid explicitly specifying -Wl,--as-needed linker flag.
  * Apply multi-arch hints. + libslopy7.6: Add Multi-Arch: same.

  [ Jakob Haufe ]
  * Add Salsa CI config
  * Build with C++17 (Closes: #1092322)
  * Bump Standards-Version
  * Split B-D
  * Add symbols file
  * Switch to pkgconf

 -- Jakob Haufe <sur5r@debian.org>  Sun, 23 Mar 2025 19:45:20 +0100

slop (7.6-4) unstable; urgency=medium

  * Adopt package: (Closes: #1030005)
  * Add versioned Breaks+Replaces for libslopy-dev (Closes: #1034953)

 -- Jakob Haufe <sur5r@debian.org>  Sun, 07 May 2023 11:07:14 +0200

slop (7.6-3) unstable; urgency=medium

  * upload to unstable
  * fix upgrade from monolith slop package, thanks georgesk (Closes: #1014265)

 -- Antoine Beaupré <anarcat@debian.org>  Mon, 11 Jul 2022 14:09:52 -0400

slop (7.6-2) experimental; urgency=medium

  * split out shared library in new binary packages (Closes: #1009010)
  * update debian/copyright to cover for missing files, thanks Thorsten

 -- Antoine Beaupré <anarcat@debian.org>  Wed, 01 Jun 2022 15:15:38 -0400

slop (7.6-1) unstable; urgency=medium

  * acknowledge NMU, thanks georgesk!
  * new upstream release
  * fix watch file

 -- Antoine Beaupré <anarcat@debian.org>  Thu, 31 Mar 2022 12:20:45 -0400

slop (7.5-1.1) unstable; urgency=medium

  * Non Maintainer Upload: fix #994824 (slop: FTBFS on sid)
  * added an include directive for X11/Xutil.h

 -- Georges Khaznadar <georgesk@debian.org>  Fri, 01 Oct 2021 09:17:09 +0200

=== debian/control ===
--- 
+++ 
@@ -1,24 +1,26 @@
 Source: slop
 Section: x11
 Priority: optional
-Maintainer: Antoine Beaupré <anarcat@debian.org>
-Build-Depends: debhelper (>= 10~)
-             , cmake (>= 3.1.3~)
-             , libegl1-mesa-dev
-             , libicu-dev
-             , libglew-dev
-             , libglm-dev
-             , libxext-dev
-             , libxrender-dev
-             , pkg-config
-Standards-Version: 4.2.1.0
+Maintainer: Jakob Haufe <sur5r@debian.org>
+Build-Depends: debhelper-compat ( =13),
+Build-Depends-Arch: cmake (>= 3.1.3~),
+                    libegl1-mesa-dev,
+                    libglew-dev,
+                    libglm-dev,
+                    libicu-dev,
+                    libxext-dev,
+                    libxrender-dev,
+                    pkgconf,
+Standards-Version: 4.7.2
+Rules-Requires-Root: no
 Homepage: https://github.com/naelstrof/slop
 Vcs-Git: https://salsa.debian.org/debian/slop.git
 Vcs-Browser: https://salsa.debian.org/debian/slop
 
 Package: slop
 Architecture: any
-Depends: ${shlibs:Depends}, ${misc:Depends}
+Depends: ${misc:Depends},
+         ${shlibs:Depends},
 Description: queries for a selection from the user and prints the region to stdout
  slop (Select Operation) is an application that queries for a
  selection from the user and prints the region to stdout. It grabs the
@@ -49,3 +51,35 @@
   * Supports textured themes.
   * Supports programmable shaders.
   * Supports a magnifying glass.
+
+Package: libslopy-dev
+Section: libdevel
+Architecture: any
+Depends: libslopy7.6 (= ${binary:Version}),
+         ${misc:Depends},
+Breaks: slop (<< 7.6-2),
+Replaces: slop (<< 7.6-2),
+Description: queries for a selection from the user and prints the region to stdout
+ slop (Select Operation) is an application that queries for a
+ selection from the user and prints the region to stdout. It grabs the
+ mouse and turns it into a crosshair, lets the user click and drag to
+ make a selection (or click on a window) while drawing a pretty box
+ around it, then finally prints the selection's dimensions to stdout.
+ .
+ This package contains the development files.
+
+Package: libslopy7.6
+Architecture: any
+Depends: ${misc:Depends},
+         ${shlibs:Depends},
+Breaks: slop (<< 7.6-2),
+Replaces: slop (<< 7.6-2),
+Multi-Arch: same
+Description: queries for a selection from the user and prints the region to stdout
+ slop (Select Operation) is an application that queries for a
+ selection from the user and prints the region to stdout. It grabs the
+ mouse and turns it into a crosshair, lets the user click and drag to
+ make a selection (or click on a window) while drawing a pretty box
+ around it, then finally prints the selection's dimensions to stdout.
+ .
+ This package contains the shared library.

=== debian/rules ===
--- 
+++ 
@@ -14,7 +14,6 @@
 # package maintainers to append CFLAGS
 export DEB_CFLAGS_MAINT_APPEND  = -Wall -pedantic
 # package maintainers to append LDFLAGS
-export DEB_LDFLAGS_MAINT_APPEND = -Wl,--as-needed
 
 
 # main packaging script based on dh7 syntax

## slop 7.7

=== debian/changelog ===
slop (7.7-2) unstable; urgency=medium

  * Mark C++ STL symbol as optional (Closes: #1114385)

 -- Jakob Haufe <sur5r@debian.org>  Tue, 07 Oct 2025 13:50:37 +0200

slop (7.7-1) unstable; urgency=medium

  * New upstream version (Closes: #1113511)
  * Drop d/patches: Applied upstream
  * Update library packaging for new upstream version (Closes: #1114385)
  * Update watchfile
  * Clean up d/rules

 -- Jakob Haufe <sur5r@debian.org>  Fri, 03 Oct 2025 18:01:15 +0200

=== debian/control ===
--- 
+++ 
@@ -55,10 +55,8 @@
 Package: libslopy-dev
 Section: libdevel
 Architecture: any
-Depends: libslopy7.6 (= ${binary:Version}),
+Depends: libslopy7.7 (= ${binary:Version}),
          ${misc:Depends},
-Breaks: slop (<< 7.6-2),
-Replaces: slop (<< 7.6-2),
 Description: queries for a selection from the user and prints the region to stdout
  slop (Select Operation) is an application that queries for a
  selection from the user and prints the region to stdout. It grabs the
@@ -68,12 +66,11 @@
  .
  This package contains the development files.
 
-Package: libslopy7.6
+Package: libslopy7.7
+Section: libs
 Architecture: any
 Depends: ${misc:Depends},
          ${shlibs:Depends},
-Breaks: slop (<< 7.6-2),
-Replaces: slop (<< 7.6-2),
 Multi-Arch: same
 Description: queries for a selection from the user and prints the region to stdout
  slop (Select Operation) is an application that queries for a

=== debian/rules ===
#!/usr/bin/make -f
# See debhelper(7) (uncomment to enable)
# output every command that modifies files on the build system.
#DH_VERBOSE = 1

export DEB_BUILD_MAINT_OPTIONS = hardening=+all

%:
	dh $@

=== debian/watch ===
Version: 5

Source: https://api.github.com/repos/naelstrof/slop/tags
Matching-Pattern: https://api.github.com/repos/naelstrof/slop/tarball/refs/tags/v(\d.\d)
Filenamemangle: s/.+\/v?(\d.\d)/slop-$1\.tar\.gz/
Searchmode: plain
